/* Copyright 2006 Ikeda Yasuyuki
** 
** This file is part of ipenv.
** 
** ipenv is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** any later version.
** 
** ipenv is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with ipenv; if not, write to the Free Software
** Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
** 
*/

#ifndef __MOD_IPENV_H__
#define __MOD_IPENV_H__

#define BUFFER_SIZE	(1024)
#define EBUFFER_SIZE	(128)

#define IPENV_INIT_ENTRYSIZE	(2)
#define IPENV_INIT_REMOTESIZE	(10)

typedef enum{
	IPENV_SET
	, IPENV_UNSET
}ipenv_setenv;

typedef enum{
	IPENV_TYPE_IP
	,IPENV_TYPE_HOST
	,IPENV_TYPE_DOMAIN
	,IPENV_TYPE_FAIL
}ipenv_remote_type;

typedef enum{
	IPENV_NOTRESOLVED
	, IPENV_RESOLVEFAILED
	, IPENV_RESOLVED
}ipenv_resolve;

typedef struct{
	ipenv_remote_type type;
	union {
		char *host;
		char *domain;
		apr_ipsubnet_t *ip;
	}x;
}ipenv_remote;

typedef struct {
	const char* filename;
	ipenv_setenv setenv;
	const char* envname;
	
	apr_array_header_t* remote_list;	/*list of ipenv_remote*/
}ipenv_entry;

typedef struct{
	const char* path;
	apr_array_header_t* entry_list;	/*list of ipenv_entry*/
}ipenv_dir_conf;


module AP_MODULE_DECLARE_DATA ipenv_module;

#endif /*__MOD_IPENV_H__*/
